
public class ReadWriteLock {
	private int readers = 0;
	private boolean writing = false;
	private waitingW = 0;
	private boolean readersturn = false;

	public synchronized void acquireRead(String id) throws InterruptedException {
		while (!(!this.writing && (waitingW==0 || readersturn))) {
			this.wait();
		}
		++this.readers;
		// this.notifyAll(); // nicht ntig
		System.out.println("READER "+id+" ACQUIRED");
	}

	public synchronized void releaseRead(String id) {
		--this.readers;
		readersturn = false;
		if (this.readers == 0) {
			this.notifyAll();
		}
		System.out.println("READER "+id+" RELEASED");
	}

	public synchronized void acquireWrite(String id)
			throws InterruptedException {
		while (!(this.readers == 0 && !this.writing && !readersturn)) {
			this.wait();
		}
		this.writing = true;
		--waitingW;
		// this.notifyAll(); // nicht ntig
		System.out.println("WRITER "+id+" ACQUIRED");
	}

	public synchronized void releaseWrite(String id) {
		this.writing = false;
		readersturn = true;
		this.notifyAll();
		System.out.println("WRITER "+id+" RELEASED");
	}

	public synchronized void request(String id) {
		++this.waitingW;
		System.out.println("WRITER "+id+" REQUESTED");
	}

}
